#Cross-platfrom text2speech plugin for Openkore.
#You need Festival if you want to use it.
#Usage: say < text >. Where < text > is text that you want ;).
#By Kissa2k.

package festivalSpeech;

use strict;
use IO::Socket;
use Plugins;
use Globals;
use Log qw(message error warning);

Plugins::register('festivalSpeech', 'Speech using Festival speech engine', \&Unload, \&Unload);
  
my $hook = Commands::register(
	['say', "speech text", \&SayIt]
);

sub Unload {
	Commands::unregister($hook);
}

sub trim {
	my($string)=@_;
	for ($string) {
		s/^\s+//;
		s/\s+$//;
	}
	return $string;
}


sub SayIt {
	my (undef, $args) = @_;
	my @args = split(/ /, $args);
	my $data;
	my $message;
	my $socket = new IO::Socket::INET(
		PeerAddr => "127.0.0.1",
		PeerPort => '1314',
		Proto => 'tcp');
	unless ($socket) {
		error "[festivalSpeech] Cannot connect to Festival server: $@\n";
		error "[festivalSpeech] Does Festival running with --server option?";
		return 2
	}
	for(my $i=0; $i<=@args; $i++){
		$message=$message." ".$args[$i];
	}
	$message=trim($message);
	print $socket "(SayText \"$message\")\n";
	message "[festivalSpeech] Saying $message\n";
	$data=<$socket>;
	if($data){
		message "[festivalSpeech] Done.\n";	
	}else{
		error "[festivalSpeech] Unknown error!\n"	
	}
}

1;
